<?php

	date_default_timezone_set("Africa/Johannesburg");

	//	Variables

	$User = "72093465";
	$Password = "UDFFoC";

	//
	//	Perform a balance enquiry
	//

	$Document = new DOMDocument("1.0","UTF-8");
	$BalanceNode = $Document->createElement("balance");
	$BalanceNode->setAttribute("user",$User);																								// Set the user
	$BalanceNode->setAttribute("password",$Password);																					// Set the password
	$Document->appendChild($BalanceNode);
	$PostData = $Document->saveXML();
	unset($Document);
	DoSend($PostData);

	//
	//	Check for inbound messages
	//

	$Document = new DOMDocument("1.0","UTF-8");
	$ReceiveNode = $Document->createElement("receive");
	$ReceiveNode->setAttribute("user",$User);																								// Set the user
	$ReceiveNode->setAttribute("password",$Password);																					// Set the password
	$Document->appendChild($ReceiveNode);
	$PostData = $Document->saveXML();
	unset($Document);
	DoSend($PostData);

	//
	//	Send messages
	//

	$Document = new DOMDocument("1.0","UTF-8");
	$SendNode = $Document->createElement("send");
	$SendNode->setAttribute("user",$User);																								// Set the user
	$SendNode->setAttribute("password",$Password);																					// Set the password
	$SendNode->setAttribute("from","808081");																							// Use 808081 as the source address
	$SendNode->setAttribute("notify","http://myserver.co.za/notify.php");													//	POST delivery notifications to this url
	$SendNode->setAttribute("reply","http://myserver.co.za/reply.php");														//	POST reply messages to this url
	$SendNode->setAttribute("concatenate","2");																						// 0 - trim , 1 - split messages , 2 - full concatenation
	$SendNode->setAttribute("validity","48h");																						// {n}minutes , {n}hours , {n}days

	//	If you want to schedule the messages

	//$Sheduled = date("Y-m-d H:i:s",(time()+(60*10)));																				// Schedule the messages for 10 minutes from now
	//$SendNode->setAttribute("scheduled",$Sheduled);																					// yyyy-mm-dd hh:mm:ss    in 24 hour format

	//	If you want to send a flash message


	//$SendNode->setAttribute("type","flash");																							// 16bit , ucs2 , binary , flash

	//	Add the messages messages

	for ($i=0;$i<5;$i++) {
		$PhoneNumber = "+27" . mt_rand(6,8) . mt_rand(2,4) . mt_rand(1000000,9999999);
		$MessageNode = $Document->createElement("message","Test message to ${PhoneNumber} using the HTTP Protocol");
		$MessageNode->setAttribute("to",$PhoneNumber);
		$SendNode->appendChild($MessageNode);
	}

	$Document->appendChild($SendNode);
	$PostData = $Document->saveXML();
	unset($Document);
	DoSend($PostData);

	//**************************************************************************************************************************************************************
	//	Send bulk messages (this is to send the same message text to list of mobile numbers)
	//**************************************************************************************************************************************************************

	$Document = new DOMDocument("1.0","UTF-8");
	$SendNode = $Document->createElement("send");
	$SendNode->setAttribute("user",$User);																								// Set the user
	$SendNode->setAttribute("password",$Password);																					// Set the password
	$SendNode->setAttribute("notify","http://myserver.co.za/notify.php");													//	POST delivery notifications to this url
	$SendNode->setAttribute("reply","http://myserver.co.za/reply.php");														//	POST reply messages to this url
	$SendNode->setAttribute("concatenate","2");																						// 0 - trim , 1 - split messages , 2 - full concatenation
	$SendNode->setAttribute("validity","48h");																						// {n}minutes , {n}hours , {n}days
	$SendNode->setAttribute("from","+27821111111");																					// The requested source address
	$Text = $Document->createCDATASection("The bulk message to be sent to a list of numbers");
	$SendNode->appendChild($Text);

	//	If you want to schedule the messages

	//$Sheduled = date("Y-m-d H:i:s",(time()+(60*10)));																				// Schedule the messages for 10 minutes from now
	//$SendNode->setAttribute("scheduled",$Sheduled);																					// yyyy-mm-dd hh:mm:ss    in 24 hour format

	//	If you want to send a flash message

	//$SendNode->setAttribute("type","flash");																							// 16bit , ucs2 , binary , flash

	//	Add messages (this can be repeated up to 100000 times)

	for ($i=0;$i<5;$i++) {
		$PhoneNumber = "+27" . mt_rand(6,8) . mt_rand(2,4) . mt_rand(1000000,9999999);
		$MessageNode = $Document->createElement("message");
		$MessageNode->setAttribute("to",$PhoneNumber);
		$SendNode->appendChild($MessageNode);
	}

	$Document->appendChild($SendNode);
	$PostData = $Document->saveXML();
	unset($Document);
	DoSend($PostData);


//***************************************************************************************************************************
//*	DoSend()
//*
//*		Send the request
//***************************************************************************************************************************
function DoSend($PostData)
{
	$Protocol = "http:";
	$Server = "smsserver.channelmobile.co.za";
	$Port = 8088;
	$URL = $Protocol . "//" . $Server . ":" . $Port;

	$Handle = curl_init();
	curl_setopt($Handle,CURLOPT_URL,$URL);
	curl_setopt($Handle,CURLOPT_POST,true);
	curl_setopt($Handle,CURLOPT_PORT,$Port);
	curl_setopt($Handle,CURLOPT_POSTFIELDS,$PostData);
	curl_setopt($Handle,CURLOPT_RETURNTRANSFER,true);
	curl_setopt($Handle,CURLOPT_CONNECTTIMEOUT,10);
	curl_setopt($Handle,CURLOPT_TIMEOUT,10);

	echo "SEND: ${PostData}\n";
	if (!($Response = curl_exec($Handle))) {
		echo "ERROR - " . curl_error($Handle) . "\n";
		return false;
	}
	echo "RESPONSE: ${Response}\n";
	curl_close($Handle);
	return true;
}

?>